FROM ubuntu:22.04

ARG DEBIAN_FRONTEND=noninteractive
RUN apt update && apt install -y wget libgtk-3-0 libpcsclite-dev pcscd curl software-properties-common git zip bash
RUN add-apt-repository ppa:ondrej/php
RUN apt update && apt install -y \
    php-fpm  \
    php-curl \
    php \
    php-common \
    php-cli \
    php-xml \
    gnupg \
    g++ \
    procps \
    git \
    unzip \
    zlib1g-dev \
    libzip-dev \
    libfreetype6-dev \
    libpng-dev \
    libjpeg-dev \
    libicu-dev  \
    libonig-dev \
    libxslt1-dev \
    acl \
    && echo 'alias sf="php bin/console"' >> ~/.bashrc

RUN wget -q -O /etc/apt/trusted.gpg.d/lab50.gpg http://packages.lab50.net/lab50.gpg
RUN echo 'deb http://packages.lab50.net/okular jammy main non-free' > /etc/apt/sources.list.d/okulargost.list
COPY 3party/cprocsp/linux-amd64_deb.tgz /tmp/src/
RUN cd /tmp/src && \
    tar -xf linux-amd64_deb.tgz && \
    linux-amd64_deb/install.sh && \
    dpkg -i linux-amd64_deb/cprocsp-pki-cades-64*.deb && \
    dpkg -i linux-amd64_deb/cprocsp-rdr-* && \
    # делаем симлинки 
    cd /bin && \
    ln -s /opt/cprocsp/bin/amd64/certmgr && \
    ln -s /opt/cprocsp/bin/amd64/cpverify && \
    ln -s /opt/cprocsp/bin/amd64/cryptcp && \
    ln -s /opt/cprocsp/bin/amd64/csptest && \
    ln -s /opt/cprocsp/bin/amd64/csptestf && \
    ln -s /opt/cprocsp/bin/amd64/der2xer && \
    ln -s /opt/cprocsp/bin/amd64/inittst && \
    ln -s /opt/cprocsp/bin/amd64/wipefile && \
    ln -s /opt/cprocsp/sbin/amd64/cpconfig && \
    #прибираемся
    rm -rf /tmp/src

COPY 3party/okular/install.sh /tmp/
RUN bash /tmp/install.sh && rm -fv /tmp/install.sh
RUN apt update && apt install -y okular-csp-utils

RUN mkdir -p /root/.config
COPY license.key /license.key
RUN echo Y | pdfcpro install-license /license.key
COPY Inter-Bold.ttf /usr/local/share/fonts/Inter-Bold.ttf

RUN curl -sS https://getcomposer.org/installer | php -- --install-dir=/usr/local/bin --filename=composer

WORKDIR /usr/src/signer/
COPY ./backend /usr/src/signer

COPY ./docker/php/www.conf /etc/php/8.3/fpm/pool.d/www.conf

ENV COMPOSER_ALLOW_SUPERUSER=1
RUN composer install
RUN service php8.3-fpm start

COPY entrypoint.sh /entrypoint.sh

ENTRYPOINT [ "/entrypoint.sh" ]
CMD ["php-fpm8.3", "-F"]

EXPOSE 9000